import java.io.PrintWriter;
import java.util.*;
public class BookFactory {
	private Class cls;
	private boolean trace=false;
	
	public static void main(String[] args) throws Exception {
		String title = "Java 2";
		String author = "Ivor Horton";
		String isbn = "0764568744";
		String price = "$33";
			
		BookFactory fac = new BookFactory("CSEBook",true);
		Book b = fac.newInstance(title, author, isbn, price);
		System.out.println("Calling methods of Book Interface with Trace on:");
		
		b.getTitle();
		b.getAuthor();
		b.getIsbn();
		b.getPrice();
		
		System.out.println("Output complete for Trace on\n");
		
		fac = new BookFactory("CSEBook",false);
		b = fac.newInstance(title, author, isbn, price);
		System.out.println("Calling methods of Book Interface with Trace off:");
		
		b.getTitle();
		b.getAuthor();
		b.getIsbn();
		b.getPrice();
		
		System.out.println("Output complete for Trace off");
		
	
	}
	
	public BookFactory(String name, boolean trace) throws Exception{
		cls = Class.forName(name);
		this.trace=trace;
	}
	public Book newInstance(String title, String author,
			                String isbn, String price) 
							throws Exception
	{
		Book b = (Book)cls.newInstance();
		b.initialize(title,author,isbn,price);
		
		//if trace is true, we create a return a proxy instance of Book. 
		if(trace){
			b = (Book)Trace.createProxy(b, new PrintWriter(System.out,true));
		}
		return b;
	}
}