/*inspired from java.sun.com*/
/**Atish Davda**/

import java.lang.reflect.*;

public class MagicArrays {


 public static void main(String[] args) {
  //GIVEN A BUNCH OF ARRAYS, DETERMINE CLASS TYPE OF EACH
  Radio tester = new Radio();
  Field[] publicFields = ((Class)tester.getClass()).getFields();
  for(int i = 0; i < publicFields.length; i++) {
   String fieldName = publicFields[i].getName();
   String arrayType = ((Class)publicFields[i].getType()).getName();
   if(((Class)publicFields[i].getType()).isArray())
    System.out.println("Radio."+fieldName+" is an array of type "+arrayType);
  }
  
  //CREATING ARRAY OF A TYPE UNKNOWN UNTIL RUNTIME
  int[] a1 = {1,2,3,4,5};
  int[] a2 = (int[]) append5spaces(a1);
  System.out.print("a1:");
  for(int i = 0; i < a1.length; i++) System.out.print(a1[i]+" ");
  System.out.print("\na2:");
  for(int i = 0; i < a2.length; i++) System.out.print(a2[i]+" ");
  
  //CHANGING VALUES IN AN ARRAY WITH FIELDNAME UNKNOWN
  reset(a1);
  System.out.print("\na1:");
  for(int i = 0; i < a1.length; i++) System.out.print(a1[i]+" ");
  System.out.println();
 }
 
 public static Object append5spaces(Object a) {
  if(!(a.getClass()).isArray())
    return null;
  Class componentClass = a.getClass().getComponentType();
  Object a2 = Array.newInstance(componentClass,Array.getLength(a)+5);
  System.arraycopy(a,0,a2,0,Array.getLength(a));  
  return a2;
 }
 
 public static void reset(Object a) {
  //we know it is either of type Integer or int
  //so we set the value to -1 if its int
  //0 otherwise
  if(("[Ljava.lang.Integer").contains("Integer"))
    for(int i = 0; i < Array.getLength(a); i++) Array.set(a,i,0);
  else
    for(int i = 0; i < Array.getLength(a); i++) Array.set(a,i,-1);
 }
 
}

class Radio {
  public String[] message;
  public Double[] stations;
  public Integer[] presets;
  public boolean onOff;
  public Integer[] equalizer;
}
 