import java.util.*;
import java.lang.reflect.*;

public class UniqueQueue {
	private List dataList = new ArrayList();
	private Object eltArray;
	private Class eltType;
	private Method equalsMethod = null;
	
	public UniqueQueue (Class elementType){
		eltType = elementType;
		eltArray = Array.newInstance(eltType,0);
	}
	
	public UniqueQueue(Class eltType, Method equalsMethod){
		Class[] param = equalsMethod.getParameterTypes();
		
		//check for valid equals method 
		if(Modifier.isStatic(equalsMethod.getModifiers())
			&& equalsMethod.getReturnType() == boolean.class
			&& param[0]==eltType
			&& param[1]==eltType
			&& param.length==2){
		
			this.equalsMethod=equalsMethod;
			this.eltType=eltType;
			eltArray = Array.newInstance(eltType, 0);
		}
		else
			throw new RuntimeException("Invalid Method");
	}
	
	public void add(Object e) throws Exception{
		if(!eltType.isInstance(e))
			throw new RuntimeException("Illegal Argument");
		if(!contains(e))
			dataList.add(e);
	}
	
	public boolean contains(Object e) throws Exception{
		if(equalsMethod == null)
			return dataList.contains(e);
		else{
			for (int i=0;i<dataList.size();i++){
				Object[] args = {e,dataList.get(i)};
				if((Boolean) equalsMethod.invoke(e,args))
					return true;
			}
			return false;
		}
	}
	
	public Object[] toArray(){ return dataList.toArray((Object[])eltArray); }
	public boolean isEmpty() { return dataList.size()==0;}
	public int size() {return dataList.size();}
	public Object remove() {return dataList.remove(0);}
	public Object elementAt(int i){ return dataList.get(i);}
}
